Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.saxonica.ptree
Class PTreeEmitter

    java.lang.Object
      net.sf.saxon.event.Emitter
          com.saxonica.ptree.PTreeEmitter

All Implemented Interfaces:
  Result, Receiver

    public class PTreeEmitter

extends Emitter

An Emitter (serializer) to output a result tree in Saxon PTree format

Constructor Summary
`PTreeEmitter()`

Method Summary
`void` | `attribute(int nameCode, int typeCode, CharSequence value, int locationId, int properties)` Notify an attribute.
`void` | `characters(CharSequence chars, int locationId, int properties)` Notify character data.
`void` | `close()` Notify the end of the event stream
`void` | `comment(CharSequence content, int locationId, int properties)` Notify a comment.
`void` | `endDocument()` Notify the end of a document node
`void` | `endElement()` Notify the end of an element.
`void` | `namespace(int namespaceCode, int properties)` Notify a namespace.
`void` | `open()` Notify the start of the event stream
`void` | `processingInstruction(String name, CharSequence data, int locationId, int properties)` Output a processing instruction
`void` | `setPipelineConfiguration(PipelineConfiguration config)` Set the namePool in which all name codes can be found, and other configuration details
`void` | `setStreamResult(StreamResult result)` Set the StreamResult acting as the output destination of the Emitter
`void` | `startContent()` Notify the start of the content, that is, the completion of all attributes and namespaces.
`void` | `startDocument(int properties)` Notify the start of a document node
`void` | `startElement(int nameCode, int typeCode, int locationId, int properties)` Notify the start of an element

Methods inherited from class net.sf.saxon.event.Emitter
`getConfiguration, getOutputProperties, getOutputStream, getPipelineConfiguration, getSystemId, getWriter, setOutputProperties, setOutputStream, setSystemId, setUnparsedEntity, setWriter, usesWriter`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### PTreeEmitter

    public PTreeEmitter()

Method Detail

### setPipelineConfiguration

    public void setPipelineConfiguration(PipelineConfiguration config)

  Set the namePool in which all name codes can be found, and other configuration details

  Specified by:
    `setPipelineConfiguration` in interface `Receiver`
  Overrides:
    `setPipelineConfiguration` in class `Emitter`

### setStreamResult

    public void setStreamResult(StreamResult result)
                         throws XPathException

  Set the StreamResult acting as the output destination of the Emitter

  Overrides:
    `setStreamResult` in class `Emitter`
  Throws:
    `XPathException`

### attribute

    public void attribute(int nameCode,
                          int typeCode,
                          CharSequence value,
                          int locationId,
                          int properties)
                   throws XPathException

  Notify an attribute. Attributes are notified after the startElement event, and before any children. Namespaces and attributes may be intermingled.

  Parameters:
    `nameCode` - The name of the attribute, as held in the name pool
    `typeCode` - The type of the attribute, as held in the name pool
    `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Bit significant value. The following bits are defined:
  DISABLE_ESCAPING
    Disable escaping for this attribute
  NO_SPECIAL_CHARACTERS
    Attribute value contains no special characters
  Throws:
    `IllegalStateException:` - attempt to output an attribute when there is no open element start tag
    `XPathException`

### characters

    public void characters(CharSequence chars,
                           int locationId,
                           int properties)
                    throws XPathException

  Notify character data. Note that some receivers may require the character data to be sent in a single event, but in general this is not a requirement.

  Parameters:
    `chars` - The characters
    `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Bit significant value. The following bits are defined:
  DISABLE_ESCAPING
    Disable escaping for this text node
  USE_CDATA
    Output as a CDATA section
  NO_SPECIAL_CHARACTERS
    Value contains no special characters
  WHITESPACE
    Text is all whitespace
  Throws:
    `XPathException`

### close

    public void close()
               throws XPathException

  Notify the end of the event stream

  Throws:
    `XPathException`

### comment

    public void comment(CharSequence content,
                        int locationId,
                        int properties)
                 throws XPathException

  Notify a comment. Comments are only notified if they are outside the DTD.

  Parameters:
    `content` - The content of the comment
    `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the comment. The following bits are defined:
  CHECKED
    Comment is known to be legal (e.g. doesn't contain "--")
  Throws:
    `IllegalArgumentException:` - the content is invalid for an XML comment
    `XPathException`

### endDocument

    public void endDocument()
                     throws XPathException

  Notify the end of a document node

  Throws:
    `XPathException`

### endElement

    public void endElement()
                    throws XPathException

  Notify the end of an element. The receiver must maintain a stack if it needs to know which element is ending.

  Throws:
    `XPathException`

### namespace

    public void namespace(int namespaceCode,
                          int properties)
                   throws XPathException

  Notify a namespace. Namespaces are notified after the startElement event, and before any children for the element. The namespaces that are reported are only required to include those that are different from the parent element. The events represent namespace declarations and undeclarations rather than in-scope namespace nodes: an undeclaration is represented by a namespace code of zero. If the sequence of namespace events contains two A namespace must not conflict with any namespaces already used for element or attribute names.

  Parameters:
    `namespaceCode` - an integer: the top half is a prefix code, the bottom half a URI code. These may be translated into an actual prefix and URI using the name pool. A prefix code of zero represents the empty prefix (that is, the default namespace). A URI code of zero represents a URI of "", that is, a namespace undeclaration.
    `properties` - The most important property is REJECT_DUPLICATES. If this property is set, the namespace declaration will be rejected if it conflicts with a previous declaration of the same prefix. If the property is not set, the namespace declaration will be ignored if it conflicts with a previous declaration. This reflects the fact that when copying a tree, namespaces for child elements are emitted before the namespaces of their parent element. Unfortunately this conflicts with the XSLT rule for complex content construction, where the recovery action in the event of conflicts is to take the namespace that comes last. XSLT therefore doesn't recover from this error: it sets the REJECT_DUPLICATES flag, and this is treated as a hard error.
  Throws:
    `XPathException`

### open

    public void open()
              throws XPathException

  Notify the start of the event stream

  Throws:
    `XPathException`

### processingInstruction

    public void processingInstruction(String name,
                                      CharSequence data,
                                      int locationId,
                                      int properties)
                               throws XPathException

  Output a processing instruction

  Parameters:
    `name` - The PI name. This must be a legal name (it will not be checked).
    `data` - The data portion of the processing instruction
    `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the PI. The following bits are defined:
  CHECKED
    Data is known to be legal (e.g. doesn't contain "?>")
  Throws:
    `IllegalArgumentException:` - the content is invalid for an XML processing instruction
    `XPathException`

### startContent

    public void startContent()
                      throws XPathException

  Notify the start of the content, that is, the completion of all attributes and namespaces. Note that the initial receiver of output from XSLT instructions will not receive this event, it has to detect it itself. Note that this event is reported for every element even if it has no attributes, no namespaces, and no content.

  Throws:
    `XPathException`

### startDocument

    public void startDocument(int properties)
                       throws XPathException

  Notify the start of a document node

  Throws:
    `XPathException`

### startElement

    public void startElement(int nameCode,
                             int typeCode,
                             int locationId,
                             int properties)
                      throws XPathException

  Notify the start of an element

  Parameters:
    `nameCode` - integer code identifying the name of the element within the name pool.
    `typeCode` - integer code identifying the element's type within the name pool. The value -1 indicates the default type, xs:untyped.
    `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - bit-significant properties of the element node. If there are no revelant properties, zero is supplied.
  Throws:
    `XPathException`

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.